# jeu de Mastermind, md(-1) parametres par defaut, md() pour les definir
# D'apres le script de Aurelien Bossard pour Numworks
# https://workshop.numworks.com/python/aurelienbossard/mastermind
def md(long=0,Color=0,multi=-1,vide=-1):
  larg=4
  if long==-1:
    long=15
    Color=6
    multi=0
    vide=0
  if long==0:
    long=min(15,max(1,int(input("Nombre d'essais ?"))))
  if Color==0:
    Color=min(12,max(4,int(input("Nombre de Couleurs ?"))))
  if multi==-1:
    multi=int(input("Doublons 0/1 ?"))
  if vide==-1:
    vide=int(input("Cases vides 0/1 ?"))
  for y in range(20,20+20*larg+1,20):
    draw_line(0,y, 20*long+1,y,0)
  for x in range(0,20*long+1,20):
    draw_line( x,20,x,20+20*larg,0)
  Colors=[red,blue,green,yellow,magenta,cyan,black,544,63872,28672,10,55296,1760,27,65376,64288,63500,1247,63515,2028]
  Couleur=Colors[0:Color]
  if vide==1:
    Couleur.append(65535)
  for a in range(0,len(Couleur)):
    draw_circle(10+20*a,210,8,Couleur[a]+filled)
    draw_string(str(a+1),20*a,184)
  for x in range(0,20*len(Couleur)+1):
    for y in range(185,221,15):
      if y>200:
        y+=5
      set_pixel(x,y,0)    
  for x in range(0,20*len(Couleur)+1,20):
    draw_line(x,185,x,220,0)
  code=[]
  compteur=0
  while compteur<larg:
    Rand=choice(Couleur)
    if multi==0:
      if Rand not in code:
        code.append(Rand)
        compteur+=1
    else:
      code.append(Rand)
      compteur+=1
  Longueur=-1 
  while Longueur<long-1:
    liste=[]
    Longueur+=1
    largueur=0
    while largueur<larg:
      c=input("")
      if c=="":
        continue
      c=int(c)-1
      if 0<=c<len(Couleur):
        draw_circle(10+20*Longueur,30+20*largueur,8,Couleur[c]+filled)
        largueur+=1
        liste.append(Couleur[c])
    comp=[]
    copyl=[]
    copyc=[]
    for a in range(0,larg):
      copyc.append(code[a])
      copyl.append(liste[a])
    for a in range(0,larg):
      if copyl[a]==copyc[a]:
        comp.append(0)
        copyc[a]=0
        copyl[a]=1
    for a in range(0,larg):
      for b in range(0,larg):
        if copyl[a]==copyc[b]:
          comp.append(55296)
          copyl[a]=1
          copyc[b]=0
    for a in range(0,len(comp)):
        fill_rect(1+10*(a%2)+20*Longueur,21+20*larg+10*(int(a/2)),10,10,comp[a])
    if liste==code:
      draw_string("Gagne ! :"+str(Longueur+1)+" coups",20,160)
      return 1
  draw_string("Perdu !",20,160)
  for a in range(0,len(code)):
    draw_circle(310,30+20*a,8,code[a]+filled)
  for a in range(0,len(code)):
    draw_rectangle(300,20+20*a,20,20)
  return 0
