# recherche des racines de f par dichotomie
# sur [a,b] precision eps
def dicho(f,a,b,eps):
    # local c,niter;
    if f(a)*f(b)>=0: 
        return "erreur: f(a)*f(b)>=0"
    while b-a>eps:
        c=(a+b)/2.0
        if f(a)*f(c)>0:
            a=c
        else:
            b=c
    return c

f(x):=cos(x)-x
dicho(f,0.0,1.0,1e-8)

# on peut verifier graphiquement
# plot(f(x),x,0,1)
