# distance de 2 points d'abscisse xa et xb sur le graphe de y=1/x
def Distance(xa,xb):
    # local ya,yb
    ya=1/xa
    yb=1/xb
    return sqrt((xb-xa)**2+(yb-ya)**2)

# longueur d'arc entre les points d'abscisse xa et xb en approchant par une ligne brisee de N segments
def Longueur(xa,xb,N):
    # local h,d,k
    h=(xb-xa)/(N*1.0) # 1.0 pour Python 2
    d=0
    for k in range(N):
        d=d+Distance(xa+k*h,xa+(k+1)*h)
    return d

# exemple de calcul entre les points d'abscisse 1 et 4 (10 subdivisions)
l=Longueur(1,4,10)
# on peut verifier avec arclen(1/x,x,1,4.0)
