# fractale de Mandelbrot en utilisant la conjugaison complexe pour accelerer
# par exemple FRA(180,180,10)
# le calcul est assez long (on peut interrompre en tapant ON).
def FRA(X,Y,Nmax):
  # local w,h,y,c,x,z,j
  w=2.7/X
  h=-1.87/Y
  Y=Y-1
  for y in range(ceiling(Y/2)+1):
    c = -2.1+i*(h*y+0.935)
    for x in range(X):
      z = 0
      for j in range(Nmax):
        if abs(z=z**2+c)>2:
          break
      set_pixel(x,24+y,126*j+2079)
      set_pixel(x,24+Y-y,126*j+2079)
      c = c+w;
    set_pixel() # synchronize screen
