# tableau de valeurs de la fonction x^2-5 dans [a,b] pas de h
def tabval(a,b,h):
    # local x,l
    l=[]
    x=a
    while x<=b:
        l.append([x,x**2-5]) 
        # on ajoute la ligne (x,f(x)) dans le tableau
        x=x+h 
    return l

# on peut ensuite modifier pour avoir le tableau de valeurs de par exemple
# f(x):=2/3*(7.4-x^2)*sqrt(14.8*x)

# puis chercher le minimum approche en faisant appel a tabval,
# en regardant d'abord puis en automatisant la recherche

def posmax(a,b,h):
    # local x,xmax,fx,fmax
    # xmax sera la position du maximum trouve jusque la
    xmax=a
    fmax=2/3*(7.4-a)**2*sqrt(14.8*a)
    x=a
    while x<=b:
        fx=2/3*(7.4-x)**2*sqrt(14.8*x)
        if fx>fmax: # fmax n'etait donc pas le max
            xmax=x # on ajuste
            fmax=fx 
        x=x+h 
    return xmax

# modifier le programme precedent pour chercher le minimum de x^4+2x+1 sur [-10,10]
# et donner la precision obtenue (10^-1, 10^-2, ...)
# que se passe-t-il pour une precision de 10^-5?
# Peut-on le determiner rapidement en appelant plusieurs fois posmax?
